﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.31
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
	
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
	nativeMe.RunMethod("Initialize", Null)
End Sub


Public Sub Speak (mystring As String, id As String)
	nativeMe.RunMethod("speakOut", Array (mystring,id))
End Sub

Public Sub clearTextToSpeech
	nativeMe.RunMethod("clearTextToSpeech", Null)
End Sub

Private Sub tts_finished(id As String)
	CallSubDelayed2(Main, "ttsFinished", id)
End Sub

Private Sub tts_error
	Log("In B4A and TTS error")
End Sub

Private Sub tts_started(id As String)
	CallSubDelayed2(Main, "ttsStarted",id)
End Sub


#If Java

  import android.speech.tts.TextToSpeech;
  import java.util.Locale;
  import android.speech.tts.UtteranceProgressListener;
  private TextToSpeech tts;
  public void Initialize() {
        tts=new TextToSpeech(BA.applicationContext, new TextToSpeech.OnInitListener() {
			@Override
			public void onInit(int status) {
			    //BA.Log("STATUS = " + status);
			    if (status == TextToSpeech.SUCCESS) {
			        tts.setOnUtteranceProgressListener(new UtteranceProgressListener() {
			            @Override
			            public void onDone(String utteranceId) {
			                //BA.Log("TTS finished");
							//BA.Log(" ");
							ba.raiseEventFromUI(this, "tts_finished", utteranceId);}
			            @Override
			            public void onError(String utteranceId) {
						    //BA.Log("TTS error");
							//BA.Log(" ");
							ba.raiseEventFromUI(this, "tts_error", null);}
			            @Override
			            public void onStart(String utteranceId) {
						    //BA.Log("TTS start");
							//BA.Log(" ");
							ba.raiseEventFromUI(this, "tts_started", utteranceId);}});
			    } else {BA.Log("Initilization Failed!");}}});}
  public void speakOut(String str, String utteranceId) {
          tts.speak(str, TextToSpeech.QUEUE_ADD, null, utteranceId );}
  public void clearTextToSpeech() {
      // Don't forget to shutdown tts!
      if (tts != null) {
          tts.stop();
          tts.shutdown();}}
#End If